<?php

namespace Drupal\simple_oauth_claims;

use Drupal\Core\Database\Database;
use Drupal\Core\DependencyInjection\ContainerBuilder;
use Drupal\Core\DependencyInjection\ServiceProviderBase;

/**
 * Defines a service provider for the simple_oauth_claims module.
 */
class SimpleOauthClaimsServiceProvider extends ServiceProviderBase {

  /**
   * {@inheritdoc}
   */
  public function alter(ContainerBuilder $container) {
    // Workaround to access the data before containers have been built.
    // Hopefully the 'cache_config' table is there and not e.g.
    // in some key-value store.
    $db = Database::getConnection('default');
    $claims = $db
      ->query("select cid, data from {cache_config} where cid = 'simple_oauth_claims.claim.welcome_dialog'")
      ->fetchAll();

    $claim_names = $container->getParameter('simple_oauth.openid.claims');

    // Add configured claim names.
    foreach ($claims as $claim) {
      $data = unserialize($claim->data);
      if ($data['type'] !== 'oidc') {
        continue;
      }
      $claim_names[] = $data['name'];
      $container->setParameter('simple_oauth.openid.claims', $claim_names);
    }
  }

}
